<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\spare_part;


use app\common\model\spare_part\SparePart;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * SparePart逻辑
 * Class SparePartLogic
 * @package app\adminapi\logic
 */
class SparePartLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/09/14 15:08
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            $params['goods_category_id'] = end($params['goods_category_id']);
            SparePart::create([
                'goods_category_id' => $params['goods_category_id'],
                'spare_name' => $params['spare_name'],
                'spare_image' => $params['spare_image'],
                'spare_number' => $params['spare_number'],
                'spare_unit' => $params['spare_unit'],
                'company_price' => $params['company_price'],
                'original_price' => $params['original_price'],
                'offering_price' => $params['offering_price'],
                'spare_status' => $params['spare_status'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/09/14 15:08
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            $params['goods_category_id'] = end($params['goods_category_id']);
            SparePart::where('id', $params['id'])->update([
                'goods_category_id' => $params['goods_category_id'],
                'spare_name' => $params['spare_name'],
                'spare_image' => $params['spare_image'],
                'spare_number' => $params['spare_number'],
                'spare_unit' => $params['spare_unit'],
                'company_price' => $params['company_price'],
                'original_price' => $params['original_price'],
                'offering_price' => $params['offering_price'],
                'spare_status' => $params['spare_status'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/09/14 15:08
     */
    public static function delete(array $params): bool
    {
        return SparePart::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2024/09/14 15:08
     */
    public static function detail($params): array
    {
        return SparePart::findOrEmpty($params['id'])->toArray();
    }
}